<template>
  <div class="app-container">
    <el-row :gutter="20">
      <!--机构数据-->
      <el-col :span="4" :xs="24">
        <k-org-tree v-model="queryParams.orgId" @defaultKey="getDefaultKey" @checkChange="checkChange"
                    @click="clickTreeNode"></k-org-tree>
      </el-col>
      <!--用户数据-->
      <el-col :span="20" :xs="24">

        <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch"
                 label-width="68px">

          <el-form-item label="资料类型" prop="knowledgeId">
            <el-select v-model="queryParams.knowledgeId" placeholder="请选择资料类型" clearable>
              <el-option v-for="item in knowledgeList" :key="item.id" :label="item.name" :value="item.id"></el-option>
            </el-select>
          </el-form-item>


          <el-form-item label="公开状态" prop="isOpen">
            <el-select v-model="queryParams.isOpen" placeholder="请选择资料类型" clearable>
              <el-option v-for="item in openOption" :key="item.value" :label="item.label"
                         :value="item.value"></el-option>
            </el-select>
          </el-form-item>

          <el-form-item label="资料标题" prop="title">
            <el-input
              v-model="queryParams.title"
              placeholder="请输入资料标题"
              clearable
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>

          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button
              type="primary"
              plain
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd"
              v-hasPermi="['core:materials:add']"
            >新增
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              type="success"
              plain
              icon="el-icon-edit"
              size="mini"
              :disabled="single"
              @click="handleUpdate"
              v-hasPermi="['core:materials:edit']"
            >修改
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              type="danger"
              plain
              icon="el-icon-delete"
              size="mini"
              :disabled="multiple"
              @click="handleDelete"
              v-hasPermi="['core:materials:remove']"
            >删除
            </el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              type="warning"
              plain
              icon="el-icon-download"
              size="mini"
              @click="handleExport"
              v-hasPermi="['core:materials:export']"
            >导出
            </el-button>
          </el-col>
          <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
        <!-- 表格数据 -->
        <el-table v-loading="loading" :data="materialsList" @selection-change="handleSelectionChange">
          <el-table-column type="selection" width="55" align="center"/>
          <el-table-column label="资料标题" align="center" prop="title"/>
          <el-table-column label="资料类型" align="center" prop="knowledgeName"/>
          <el-table-column label="机构名称" align="center" prop="orgName"/>
          <el-table-column label="公开状态" align="center" prop="isOpen">
            <template slot-scope="r">{{ r.row.isOpen == 0 ? '未公开' : '公开' }}</template>
          </el-table-column>
          <el-table-column label="上传人" align="center" prop="createBy"/>
          <el-table-column label="上传时间" align="center" prop="createTime"/>
          <el-table-column label="附件" align="center" prop="fileList"/>
          <el-table-column label="备注" align="center" prop="remark"/>

          <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
            <template slot-scope="scope">
              <!-- 公开 按钮显示逻辑: 仅当前用户上传的学习资料且处于未公开状态-->
              <el-button
                v-if="checkCanEditOpen(scope.row)&&scope.row.isOpen==0"
                size="mini"
                type="text"
                icon="el-icon-edit"
                @click="handleOpen(scope.row,1)"
                v-hasPermi="['core:materials:edit']"
              >公开
              </el-button>
              <!-- 取消公开 按钮显示逻辑: 仅当前用户上传的学习资料且处于公开状态-->
              <el-button
                v-if="checkCanEditOpen(scope.row)&&scope.row.isOpen===1"
                size="mini"
                type="text"
                icon="el-icon-edit"
                @click="handleOpen(scope.row,0)"
                v-hasPermi="['core:materials:edit']"
              >取消公开
              </el-button>
              <!-- 编辑与删除按钮显示逻辑: 仅当前用户上传的学习资料且处于未公开状态-->
              <el-button
                v-if="checkCanEditOrDel(scope.row)"
                size="mini"
                type="text"
                icon="el-icon-edit"
                @click="handleUpdate(scope.row)"
                v-hasPermi="['core:materials:edit']"
              >修改
              </el-button>
              <el-button
                v-if="checkCanEditOrDel(scope.row)"
                size="mini"
                type="text"
                icon="el-icon-delete"
                @click="handleDelete(scope.row)"
                v-hasPermi="['core:materials:remove']"
              >删除
              </el-button>
            </template>
          </el-table-column>
        </el-table>

        <pagination
          v-show="total>0"
          :total="total"
          :page.sync="queryParams.pageNum"
          :limit.sync="queryParams.pageSize"
          @pagination="getList"
        />
      </el-col>
    </el-row>
    <!-- 添加或修改学习资料对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="资料标题" prop="title">
          <el-input v-model="form.title" placeholder="请输入资料标题"/>
        </el-form-item>

        <el-form-item label="资料类型" prop="knowledgeId">
          <el-select v-model="form.knowledgeId" placeholder="请选择资料类型">
            <el-option v-for="item in knowledgeList" :key="item.id" :label="item.name" :value="item.id"></el-option>
          </el-select>
        </el-form-item>

        <el-form-item label="资料内容" prop="content">
          <el-input v-model="form.content" placeholder="请输入资料内容"/>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注"/>
        </el-form-item>
        <el-form-item label="附件" prop="fileList">
          <file-upload ref="upload" @input="getFileList" v-model="form.fileList"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    c
  </div>
</template>

<script>
import {
  listMaterials,
  getMaterials,
  delMaterials,
  addMaterials,
  updateMaterials,
  editOpen
} from "@/api/core/edu/materials";
import {deptTreeSelect} from "@/api/system/public";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {queryKnowledgeList} from "@/api/core/edu/knowledge";
import OrgTree from "@/components/orgTree/index.vue";
import kOrgTree from "@/components/k-orgTree/index.vue";

export default {
  name: "Materials",
  components: {OrgTree, kOrgTree},
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 学习资料表格数据
      materialsList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 机构树选项
      deptOptions: undefined,
      // 机构名称
      deptName: undefined,
      //是否关联下级
      checked: false,
      defaultProps: {
        children: "children",
        label: "name"
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        title: null,
        knowledgeId: null,
        content: null,
        orgId: null,
        isOpen: null,
      },
      // 表单参数
      form: {},

      // 表单校验
      rules: {},
      //默认选中节点
      defaultKeys: [],
      knowledgeList: [],
      openOption: [{
        label: "公开",
        value: 1
      }, {
        label: "未公开",
        value: 0
      }],
      fileList: []
    };
  },
  watch: {
    // 根据名称筛选机构树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  created() {
    this.getDeptTree();
    this.getConfigKey("sys.user.initPassword").then(response => {
      this.initPassword = response.msg;
    });
    this.initKnowledgeList();
  },
  methods: {
    /** 查询学习资料列表 */
    getList() {
      this.loading = true;
      listMaterials(this.queryParams).then(response => {
        this.materialsList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    getDeptTree() {
      deptTreeSelect().then(response => {
        this.deptOptions = response.data;
      });
    },
    getFileList() {
      //循环获取this.$refs.upload.fileList中的name和url，放到 this.form.fileList中去
      let fileList = [];
      for (let i = 0; i < this.$refs.upload.fileList.length; i++) {
        fileList.push({name: this.$refs.upload.fileList[i].name, url: this.$refs.upload.fileList[i].url})
      }
      this.fileList = JSON.stringify(fileList);
    },
    checkCanEditOrDel(row) {
      return row.createId == this.$store.getters.userId && row.isOpen == 0;
    },
    checkCanEditOpen(row) {
      return row.createId == this.$store.getters.userId;
    },

    // 节点单击事件
    clickTreeNode(data) {
      this.queryParams.orgId = data.id;
      this.handleQuery();
    },
    /** 下穿状态改变*/
    changeCheckBox() {
      this.getList();
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        title: null,
        knowledgeId: null,
        content: null,
        orgId: this.queryParams.orgId,
        isOpen: null,
        remark: null,
        fileList: null,
      };
      this.resetForm("form");
      this.initKnowledgeList();
    },
    getDefaultKey(key) {
      this.queryParams.orgId = key;
      this.getList();
    },
    //单选框状态改变
    checkChange(state) {
      this.queryParams.checkSub = state;
      this.handleQuery();
    },
    initKnowledgeList() {
      queryKnowledgeList().then(response => {
        this.knowledgeList = response;
      })
    },

    // 筛选节点
    filterNode(value, data) {
      if (!value) return true;
      return data.name.indexOf(value) !== -1;
    },
    // 节点单击事件
    handleNodeClick(data) {
      this.queryParams.orgId = data.id;
      this.handleQuery();
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },


    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除？').then(function () {
        return delMaterials(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      });
    },

    handleOpen(row, isOpen) {
      const str = 1 === isOpen ? "公开" : "取消公开";
      this.$confirm(`确认要${str}吗？`, "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          editOpen(row.id, isOpen)
            .then(response => {
              this.$message.success("操作成功");
              this.getList();
            })
            .catch(error => {
              this.$message.error("操作失败");
            });
        })
        .catch(() => {
          // 用户取消操作
        });
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加学习资料";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getMaterials(id).then(response => {
        let fileList = response.data.fileList;
        this.form.fileList = JSON.parse(fileList);
        this.$emit("input", this.listToString(this.form.fileList));
        this.form = response.data;
        this.open = true;
        this.title = "修改学习资料";
      });
    },
    /** 提交按钮 */
    submitForm() {

      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.fileList = this.fileList;
          console.log('55555', this.form.fileList)
          if (this.form.id != null) {
            updateMaterials(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addMaterials(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    listToString(list, separator) {
      let strs = "";
      separator = separator || ",";
      for (let i in list) {
        strs += list[i].url + separator;
      }
      return strs != '' ? strs.substring(0, strs.length - 1) : '';
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('core/materials/export', {
        ...this.queryParams
      }, `materials_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
